package com.lululombard.kingnether;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World.Environment;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;

class Beacon implements Listener {

	String beaconMsg;
	boolean beaconBlockEn;
	boolean beaconLavaEn;
	String beaconBlockMsg;
	String beaconLavaMsg;
	Material ToReplaceBed = Material.BARRIER;
	
	public void init(String msg, boolean avertblock, String beaconblockmsg, boolean avertlava, String lavawarn) {
		beaconMsg = msg;
		beaconBlockEn = avertblock;
		beaconLavaEn = avertlava;
		beaconBlockMsg = beaconblockmsg;
		beaconLavaMsg = lavawarn;
	}
	
	@EventHandler(priority = EventPriority.NORMAL)
	public void onBlockPlace(BlockPlaceEvent e) {
		boolean passedBed = false;
		int blockRemove = -1;
		boolean lava = false;
		if ((!e.isCancelled()) && e.getBlock().getType().equals(Material.BEACON)) {
			Location location = e.getBlock().getLocation();
			if (location.getWorld().getEnvironment().equals(Environment.NETHER)) {
				for (int i = e.getBlock().getY(); i < 128; i++) {
					Location thisloc = location;
					thisloc.setY(i);
					Material thismaterial = thisloc.getBlock().getType();
					if (!(thismaterial.equals(Material.AIR) || thismaterial.equals(Material.BEDROCK))) blockRemove++;
					if (thismaterial.equals(Material.LAVA) || thismaterial.equals(Material.STATIONARY_LAVA)) lava = true;
					if (i >= 123) {
						if (thismaterial.equals(Material.BEDROCK)) passedBed = true;
						if (passedBed) thisloc.getBlock().setType(ToReplaceBed);
					}
				}
				if (beaconBlockEn) {
					if (blockRemove > 0) {
						String msg = beaconBlockMsg.replace("<nbblocks>", String.valueOf(blockRemove));
						if (beaconLavaEn && lava) msg = msg.replace("<avertlava>", beaconLavaMsg);
						else msg = msg.replace("<avertlava>", "");
						e.getPlayer().sendMessage(ChatColor.translateAlternateColorCodes('&', msg));
					}
				}
			}
		}
	}

	
	@EventHandler(priority = EventPriority.NORMAL)
	public void onBlockBreak(BlockBreakEvent e) {
		Location location = e.getBlock().getLocation();
		if ((!e.isCancelled()) && location.getWorld().getEnvironment().equals(Environment.NETHER)) {
			if (e.getBlock().getType().equals(Material.BEACON)) {
				for (int i = 123; i < 128; i++) {
					Location thisloc = location;
					thisloc.setY(i);
					if (thisloc.getBlock().getType().equals(ToReplaceBed)) thisloc.getBlock().setType(Material.BEDROCK);
				}
			}
			if (e.getBlock().getType().equals(ToReplaceBed) && location.getBlockY()>=123) {
				boolean canbreak = true;
				for (int i = 0; i < 128; i++) {
					Location thisloc = location;
					thisloc.setY(i);
					if (thisloc.getBlock().getType().equals(Material.BEACON)) canbreak = false;
				}
				if (!canbreak) {
					e.getPlayer().sendMessage(ChatColor.translateAlternateColorCodes('&', beaconMsg));
					e.setCancelled(true);
				}
			}
		}
	}
}
