package com.lululombard.kingnether;

import org.bukkit.ChatColor;
import org.bukkit.World;
import org.bukkit.block.BlockState;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerTeleportEvent;
import org.bukkit.event.world.StructureGrowEvent;
import org.bukkit.plugin.java.JavaPlugin;

public class KingNether extends JavaPlugin implements Listener {
	private boolean checkPos = true;
	private boolean preventBlaze = true;
	private boolean beacon = true;
	private long TicksTeleport = 40;
	private CheckPos checkPosTask = new CheckPos();
	private String disabledTeleport = "&cYour teleport to the Nether Roof has been canceled.";
	private String disabledBuild = "&cYou can't build on the Nether Roof.";
	private String roofTeleport = "&cYou've been found on the Nether's roof. To prevent any chunk corruption, you've been teleported to the world's spawn.";
	private String beaconMsg = "&cYou can't break this block as it has been replaced by the server.";
	private boolean beaconBlock = true;
	private String beaconBlockMsg = "&cThere are <nbblocks> blocks that you must remove in order to make your beacon work. <avertlava>";
	private boolean beaconBlockLava = true;
	private String beaconBlockLavaMsg = "&cWarning ! There is lava out there !";
	
	public void onEnable() {
		this.saveDefaultConfig();
		checkPos = this.getConfig().getBoolean("checkpos-enabled");
		TicksTeleport = this.getConfig().getLong("checkpos-ticks");
		disabledTeleport = this.getConfig().getString("teleport-msg");
		disabledBuild = this.getConfig().getString("build-msg");
		roofTeleport = this.getConfig().getString("checkpos-msg");
		preventBlaze = this.getConfig().getBoolean("no-fire-blaze");
		beacon = this.getConfig().getBoolean("beacon-repair");
		beaconMsg = this.getConfig().getString("beacon-msg");
		
		beaconBlock = this.getConfig().getBoolean("beacon-sendmessage");
		beaconBlockMsg = this.getConfig().getString("beacon-blocks-remove");
		
		beaconBlockLava = this.getConfig().getBoolean("beacon-avertlava");
		beaconBlockLavaMsg = this.getConfig().getString("beacon-lavamessage");
		getServer().getPluginManager().registerEvents(this, this);
		if (checkPos) {
			this.checkPosTask.init(getServer(), roofTeleport);
			getServer().getScheduler().runTaskTimerAsynchronously(this, this.checkPosTask, this.TicksTeleport, this.TicksTeleport);
		}
		if (preventBlaze) this.getServer().getPluginManager().registerEvents(new BlazePrevent(), this);
		if (beacon) {
			Beacon beaconcheck = new Beacon();
			beaconcheck.init(beaconMsg, beaconBlock, beaconBlockMsg, beaconBlockLava, beaconBlockLavaMsg);
			this.getServer().getPluginManager().registerEvents(beaconcheck, this);
		}
	}
	
	@EventHandler(priority=EventPriority.NORMAL)
	public void onBlockPlace(BlockPlaceEvent e) {
		if ((!e.isCancelled()) && (e.getBlock().getWorld().getEnvironment().equals(World.Environment.NETHER)) && (e.getBlock().getLocation().getBlockY() >= 127)) {
			String msg = ChatColor.translateAlternateColorCodes('&', disabledBuild);
			e.getPlayer().sendMessage(msg);
			e.setCancelled(true);
		}
	}

	
	@EventHandler(priority=EventPriority.NORMAL)
	public void onBlockBreak(BlockBreakEvent e) {
		if ((!e.isCancelled()) && (e.getBlock().getWorld().getEnvironment().equals(World.Environment.NETHER)) && (e.getBlock().getLocation().getBlockY() >= 127)) {
			String msg = ChatColor.translateAlternateColorCodes('&', disabledBuild);
			e.getPlayer().sendMessage(msg);
			e.setCancelled(true);
		}
	}
	
	@EventHandler(priority=EventPriority.NORMAL)
	public void onPlayerTeleport(PlayerTeleportEvent e) {
		if ((!e.isCancelled()) && (e.getTo().getWorld().getEnvironment().equals(World.Environment.NETHER)) && (e.getTo().getBlockY() >= 126)) {
			String msg = ChatColor.translateAlternateColorCodes('&', disabledTeleport);
			e.getPlayer().sendMessage(msg);
			e.setCancelled(true);
		}
	}
	
	@EventHandler(priority=EventPriority.NORMAL)
	public void onGeneration(StructureGrowEvent e) {
		if ((!e.isCancelled()) && (e.getWorld().getEnvironment().equals(World.Environment.NETHER))) {
			for (BlockState b : e.getBlocks()) if (b.getBlock().getLocation().getBlockY() >= 126) {
				e.setCancelled(true);
				getLogger().info("Prevented generation on Nether Roof");
			}
		}
	}
}
